/* eslint react/prop-types: 0 */
import { get } from 'lodash'

import { Component, documentHelpers } from 'substance'

class NoteComponent extends Component {
  didMount () {
    // TODO -- this disables the toolbar
    // TODO -- unload listener on dispose
    // TODO -- this gets registered once for each note -- to fix use didUpdate
    // this should only call disableTools
    this.context.editorSession.onUpdate('', this.noteSelected, this)
  }

  render ($$) {
    const noteContent = this.props.node['note-content']

    const el = $$('span')
      .attr('note-content', noteContent)
      .addClass('sc-note')
      .on('click', this.noteSelected)

    return el
  }

  // TODO -- should this maybe be the provider's job?
  noteSelected () {
    // TODO -- we already have the note id in the props
    const selected = this.getSelection()
    if (get(selected, 'node.type') !== 'note') return

    // this shouldn't be here
    // it should just be called when the selection updates
    // not on click of the note component
    this.disableTools(selected)

    const provider = this.getProvider()
    const noteId = selected.node.id

    provider.calloutSelected(noteId)

    // provider.showNote(selected.node)
    this.el.addClass('sc-note-active')
    this.rerender()
  }

  // TODO -- review
  disableTools () {
    const surface = this.getSurface()
    if (!surface) return
    surface.disableToolbar()

    // TODO -- do we need the rerender here??
    this.rerender()
  }

  getSelection () {
    // TODO -- write cleaner
    const surface = this.getSurface()
    if (!surface) return {}

    const session = this.context.editorSession
    const sel = session.getSelection()

    const notes = documentHelpers.getPropertyAnnotationsForSelection(
      session.getDocument(),
      sel,
      { type: 'note' }
    )

    // TODO -- scrap all below
    const note = notes[0]
    let show = false
    if (typeof note !== 'undefined') {
      if ((sel.start.offset === note.start.offset &&
        sel.end.offset === note.end.offset)) {
        show = true
      }
    }

    if (show) {
      return {
        node: note
      }
    } else {
      return {
        node: null
      }
    }
  }

  getSurface () {
    // TODO -- write with container id
    return this.context.surfaceManager.getFocusedSurface()
  }

  getCommandStates () {
    return this.context.commandManager.commandStates
  }

  getProvider () {
    return this.context.notesProvider
  }

  dispose () {
    this.props.node.off(this)
  }
}

export default NoteComponent
